Package weka.filters.unsupervised.instance

# Class RemovePercentage

java.lang.Object
weka.filters.Filter
weka.filters.unsupervised.instance.RemovePercentage

All Implemented Interfaces:
  `Serializable`, `CapabilitiesHandler`, `OptionHandler`, `RevisionHandler`, `UnsupervisedFilter`

public class RemovePercentage extends Filter implements UnsupervisedFilter, OptionHandler
A filter that removes a given percentage of a dataset.

Valid options are:

     -P <percentage>
      Specifies percentage of instances to select. (default 50)

     -V
      Specifies if inverse of selection is to be output.

Version:
  $Revision: 5548 $
Author:
  Richard Kirkby (eibe@cs.waikato.ac.nz), Eibe Frank (eibe@cs.waikato.ac.nz)
See Also:
  - Serialized Form

## Constructor Summary

Constructors
Constructor
Description
`RemovePercentage()`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`batchFinished()`
Signify that this batch of input to the filter is finished.
`Capabilities`
`getCapabilities()`
Returns the Capabilities of this filter.
`boolean`
`getInvertSelection()`
Gets if selection is to be inverted.
`String[]`
`getOptions()`
Gets the current settings of the filter.
`double`
`getPercentage()`
Gets the percentage of instances to select.
`String`
`getRevision()`
Returns the revision string.
`String`
`globalInfo()`
Returns a string describing this filter
`boolean`
`input(Instance instance)`
Input an instance for filtering.
`String`
`invertSelectionTipText()`
Returns the tip text for this property
`Enumeration`
`listOptions()`
Gets an enumeration describing the available options..
`static void`
`main(String[] argv)`
Main method for testing this class.
`String`
`percentageTipText()`
Returns the tip text for this property
`boolean`
`setInputFormat(Instances instanceInfo)`
Sets the format of the input instances.
`void`
`setInvertSelection(boolean inverse)`
Sets if selection is to be inverted.
`void`
`setOptions(String[] options)`
Parses a given list of options.
`void`
`setPercentage(double percent)`
Sets the percentage of intances to select.

### Methods inherited from class weka.filters.Filter

`batchFilterFile, filterFile, getCapabilities, getOutputFormat, isFirstBatchDone, isNewBatch, isOutputFormatDefined, makeCopies, makeCopy, numPendingOutput, output, outputPeek, toString, useFilter, wekaStaticWrapper`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### RemovePercentage

public RemovePercentage()

## Method Details

### listOptions

public Enumeration listOptions()
Gets an enumeration describing the available options..

Specified by:
  `listOptions` in interface `OptionHandler`
Returns:
  an enumeration of all the available options.

### setOptions

public void setOptions(String[] options) throws Exception
Parses a given list of options.

Valid options are:

     -P <percentage>
      Specifies percentage of instances to select. (default 50)

     -V
      Specifies if inverse of selection is to be output.

Specified by:
  `setOptions` in interface `OptionHandler`
Parameters:
  `options` - the list of options as an array of strings
Throws:
  `Exception` - if an option is not supported

### getOptions

public String[] getOptions()
Gets the current settings of the filter.

Specified by:
  `getOptions` in interface `OptionHandler`
Returns:
  an array of strings suitable for passing to setOptions

### globalInfo

public String globalInfo()
Returns a string describing this filter

Returns:
  a description of the filter suitable for displaying in the explorer/experimenter gui

### percentageTipText

public String percentageTipText()
Returns the tip text for this property

Returns:
  tip text for this property suitable for displaying in the explorer/experimenter gui

### getPercentage

public double getPercentage()
Gets the percentage of instances to select.

Returns:
  the percentage.

### setPercentage

public void setPercentage(double percent)
Sets the percentage of intances to select.

Parameters:
  `percent` - the percentage
Throws:
  `IllegalArgumentException` - if percentage out of range

### invertSelectionTipText

public String invertSelectionTipText()
Returns the tip text for this property

Returns:
  tip text for this property suitable for displaying in the explorer/experimenter gui

### getInvertSelection

public boolean getInvertSelection()
Gets if selection is to be inverted.

Returns:
  true if the selection is to be inverted

### setInvertSelection

public void setInvertSelection(boolean inverse)
Sets if selection is to be inverted.

Parameters:
  `inverse` - true if inversion is to be performed

### getCapabilities

public Capabilities getCapabilities()
Returns the Capabilities of this filter.

Specified by:
  `getCapabilities` in interface `CapabilitiesHandler`
Overrides:
  `getCapabilities` in class `Filter`
Returns:
  the capabilities of this object
See Also:
  - `Capabilities`

### setInputFormat

public boolean setInputFormat(Instances instanceInfo) throws Exception
Sets the format of the input instances.

Overrides:
  `setInputFormat` in class `Filter`
Parameters:
  `instanceInfo` - an Instances object containing the input instance structure (any instances contained in the object are ignored - only the structure is required).
Returns:
  true because outputFormat can be collected immediately
Throws:
  `Exception` - if the input format can't be set successfully

### input

public boolean input(Instance instance)
Input an instance for filtering. Ordinarily the instance is processed and made available for output immediately. Some filters require all instances be read before producing output.

Overrides:
  `input` in class `Filter`
Parameters:
  `instance` - the input instance
Returns:
  true if the filtered instance may now be collected with output().
Throws:
  `IllegalStateException` - if no input format has been set.

### batchFinished

public boolean batchFinished()
Signify that this batch of input to the filter is finished. Output() may now be called to retrieve the filtered instances.

Overrides:
  `batchFinished` in class `Filter`
Returns:
  true if there are instances pending output
Throws:
  `IllegalStateException` - if no input structure has been defined

### getRevision

public String getRevision()
Returns the revision string.

Specified by:
  `getRevision` in interface `RevisionHandler`
Overrides:
  `getRevision` in class `Filter`
Returns:
  the revision

### main

public static void main(String[] argv)
Main method for testing this class.

Parameters:
  `argv` - should contain arguments to the filter: use -h for help